/***************************************************************************
                        treefind.c  --  binary search
                             -------------------
    begin                : Wed Jun 14 17:58:28 BST 2000
    copyright            : (C) 2000 by Simon Collis
    email                : lunarship@yahoo.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public Licence as published by  *
 *   the Free Software Foundation; either version 2 of the Licence, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <stdlib.h>
#include <string.h>

/* TREEFIND -- fastest find in char** I can do */
long treefind(char **array,char *findme, long size)
{
	long i,s,lower=0,upper=size-1;

	while(1) {
		if(upper<lower) return(-1);

		i=(lower+upper)/2;

		s=strcmp(array[i],findme);

		if(s==0) return(i);

		if(s>0) {
			upper=i-1;
		} else {
			lower=i+1;
		}
	}
}
